/*****************************************************************************
* GBPCTRL.H -*- Version 3.0 -*- For use with GBP.DLL by Jiri Hruska (c) 2002 *
*  This is FREEWARE, use freely! Any comments send to: HruskaJiri@seznam.cz  *
*****************************************************************************/

#ifndef __GBP_H
#define __GBP_H

#ifndef DWORD
typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;
typedef unsigned short WCHAR;
#endif

#pragma pack(push,1)
typedef struct {
  DWORD UID;
  WORD CID;
  WORD Loc;
} PBENTRY;

typedef struct {
  BYTE Icon;
  char Number[41];
} PBNUMBER;

typedef struct {
  WORD Icon;
  WORD Length;
  WCHAR Text[40];
} PBNOTE;

typedef struct {
  BYTE OnSIM;
  BYTE Group;
  WORD HasName,HasNum1,HasNum2,HasNum3,HasNote1,HasNote2;
  WORD WordAlignPad;
  WCHAR Name[20];
  PBNUMBER Num1,Num2,Num3;
  PBNOTE Note1,Note2;
} PBRECORD;

typedef struct {
  WORD UID;
  WORD Date;
  DWORD State;
} CALENTRY;

typedef struct {
  DWORD IsToDo;
  DWORD DateTimeFlags;
  WORD Icon;
  WCHAR Text[21];
} CALRECORD;
#pragma pack(pop)

#define GBPE_NOERROR            0
#define GBPE_ALREADYOPENED     -1
#define GBPE_CANNOTOPENPORT    -2
#define GBPE_NOATRESPONSE      -3
#define GBPE_MUSTBEOPENED      -4
#define GBPE_COMMERROR         -5
#define GBPE_NOMEMORY          -6
#define GBPE_INVALIDARGS       -7

int __declspec(dllimport) __stdcall InitGBPMode(unsigned char PortNum);
int __declspec(dllimport) __stdcall EndGBPMode();
int __declspec(dllimport) __stdcall GetNVMFileSize(unsigned char Sec, unsigned char SubSec);
int __declspec(dllimport) __stdcall ClearNVMFile(unsigned char Sec, unsigned char SubSec);
int __declspec(dllimport) __stdcall ReadNVMFile(unsigned char Sec, unsigned char SubSec, void *OutBuf, unsigned long MaxLength);
int __declspec(dllimport) __stdcall WriteNVMFile(unsigned char Sec, unsigned char SubSec, void *InBuf, unsigned long Length);
int __declspec(dllimport) __stdcall ClearLock();
int __declspec(dllimport) __stdcall ReadPBDirectory(PBENTRY **pbe, DWORD MaxEntries);
int __declspec(dllimport) __stdcall ReadPBEntry(PBENTRY *pbe, PBRECORD *pbr);
int __declspec(dllimport) __stdcall WritePBEntry(PBENTRY *pbe, PBRECORD *pbr);
int __declspec(dllimport) __stdcall CreatePBEntry(PBENTRY *pbe, PBRECORD *pbr);
int __declspec(dllimport) __stdcall ErasePBEntry(PBENTRY *pbe);
int __declspec(dllimport) __stdcall ReadCalDirectory(CALENTRY **ce, DWORD MaxEntries);
int __declspec(dllimport) __stdcall ReadCalEntry(CALENTRY *ce, CALRECORD *cr);
int __declspec(dllimport) __stdcall WriteCalEntry(CALENTRY *ce, CALRECORD *cr);
int __declspec(dllimport) __stdcall CreateCalEntry(CALENTRY *ce, CALRECORD *cr);
int __declspec(dllimport) __stdcall EraseCalEntry(CALENTRY *ce);

#endif
