(*****************************************************************************
* GBPCTRL.PAS -- Version 3.0 -- For use with GBP.DLL by Jiri Hruska (c) 2002 *
*  This is FREEWARE, use freely! Any comments send to: HruskaJiri@seznam.cz  *
*****************************************************************************)

Unit GBPCtrl;

Interface

Uses Windows;

Type TPBEntry = Record
       UID:DWord;
       CID:Word;
       Loc:Word;
     end;

Type TPBRecord = Object
       Private
         Function GetOnSIM:Boolean;
         Procedure SetOnSIM(Const PlaceOnSIM:Boolean);
         Function GetName:String;
         Procedure SetName(Const NewName:String);
         Function GetNumberIcon(I:Byte):Integer;
         Procedure SetNumberIcon(I:Byte; NewIcon:Integer);
         Function GetNumber(I:Byte):String;
         Procedure SetNumber(I:Byte; Const NewNumber:String);
         Function GetNoteIcon(I:Byte):Integer;
         Procedure SetNoteIcon(I:Byte; NewIcon:Integer);
         Function GetNote(I:Byte):String;
         Procedure SetNote(I:Byte; Const NewNote:String);
       Public
         _Data:Array[0..349] of Byte;
         Property OnSIM:Boolean read GetOnSIM write SetOnSIM;
         Property Group:Byte read _Data[1] write _Data[1];
         Property Name:String read GetName write SetName;
         Property NumberIcon[I:Byte]:Integer read GetNumberIcon write SetNumberIcon;
         Property Number[I:Byte]:String read GetNumber write SetNumber;
         Property NoteIcon[I:Byte]:Integer read GetNoteIcon write SetNoteIcon;
         Property Note[I:Byte]:String read GetNote write SetNote;
         Procedure Clear;
     end;

Type TCalEntry = Record
       ID1,ID2:Word;
       ID3:DWord;
     end;

     TCalRecord = Object
       Private
         Function GetIsToDo:Boolean;
         Procedure SetIsToDo(ToDo:Boolean);
         Function GetDay:Byte;
         Procedure SetDay(A:Byte);
         Function GetMonth:Byte;
         Procedure SetMonth(A:Byte);
         Function GetYear:Byte;
         Procedure SetYear(A:Byte);
         Function GetHour:Byte;
         Procedure SetHour(A:Byte);
         Function GetMinute:Byte;
         Procedure SetMinute(A:Byte);
         Function GetAlarm:Byte;
         Procedure SetAlarm(A:Byte);
         Function GetIcon:Word;
         Procedure SetIcon(A:Word);
         Function GetText:String;
         Procedure SetText(Const A:String);
         Function GetCompleted:Boolean;
         Procedure SetCompleted(A:Boolean);
       Public
         _Data:Array[0..51] of Byte;
         Property IsToDo:Boolean read GetIsToDo write SetIsToDo;
         Property Day:Byte read GetDay write SetDay;
         Property Month:Byte read GetMonth write SetMonth;
         Property Year:Byte read GetYear write SetYear;
         Property Hour:Byte read GetHour write SetHour;
         Property Minute:Byte read GetMinute write SetMinute;
         Property Alarm:Byte read GetAlarm write SetAlarm;
         Property Icon:Word read GetIcon write SetIcon;
         Property Text:String read GetText write SetText;
         Property Completed:Boolean read GetCompleted write SetCompleted;
         Procedure Clear;
     end;

Type TGBPControl = Object
       Function Init(PortNum:Byte):Integer;
       Function Close:Integer;
       Function GetNVMSize(Section,Subsection:Byte):Integer;
       Function ClearNVMFile(Section,Subsection:Byte):Integer;
       Function ReadNVMFile(Section,Subsection:Byte; Var SrcBuffer; MaxSize:DWord):Integer;
       Function WriteNVMFile(Section,Subsection:Byte; Var DestBuffer; Size:DWord):Integer;
       Function ClearLock():Integer;
       Function ReadPBDirectory(Var pbe:Array Of TPBEntry; MaxEntries:DWord):Integer;
       Function ReadPBEntry(Var pbe:TPBEntry; Var pbr:TPBRecord):Integer;
       Function WritePBEntry(Var pbe:TPBEntry; Var pbr:TPBRecord):Integer;
       Function CreatePBEntry(Var pbe:TPBEntry; Var pbr:TPBRecord):Integer;
       Function ErasePBEntry(Var pbe:TPBEntry):Integer;
       Function ReadCalDirectory(Var ce:Array Of TCalEntry; MaxEntries:DWord):Integer;
       Function ReadCalEntry(Var ce:TCalEntry; Var cr:TCalRecord):Integer;
       Function WriteCalEntry(Var ce:TCalEntry; Var cr:TCalRecord):Integer;
       Function CreateCalEntry(Var ce:TCalEntry; Var cr:TCalRecord):Integer;
       Function EraseCalEntry(Var ce:TCalEntry):Integer;
     end;

Const GBPE_NOERROR        =  0;
      GBPE_ALREADYOPENED  = -1;
      GBPE_CANNOTOPENPORT = -2;
      GBPE_NOATRESPONSE   = -3;
      GBPE_MUSTBEOPENED   = -4;
      GBPE_COMMERROR      = -5;
      GBPE_NOMEMORY       = -6;
      GBPE_INVALIDARGS    = -7;

Implementation

Const DLLNAME = 'GBP.DLL';

Function _InitGBPMode(PortNum:Byte):Integer; stdcall; external DLLNAME name 'InitGBPMode';
Function _EndGBPMode:Integer; stdcall; external DLLNAME name 'EndGBPMode';
Function _GetNVMFileSize(Section,Subsection:Byte):Integer; stdcall; external DLLNAME name 'GetNVMFileSize';
Function _ClearNVMFile(Section,Subsection:Byte):Integer; stdcall; external DLLNAME name 'ClearNVMFile';
Function _ReadNVMFile(Section,Subsection:Byte; Var SrcBuffer; MaxSize:DWord):Integer; stdcall; external DLLNAME name 'ReadNVMFile';
Function _WriteNVMFile(Section,Subsection:Byte; Var DestBuffer; Size:DWord):Integer; stdcall; external DLLNAME name 'WriteNVMFile';
Function _ClearLock:Integer; stdcall; external DLLNAME name 'ClearLock';
Function _ReadPBDirectory(Var pbe; MaxEntries:DWord):Integer; stdcall; external DLLNAME name 'ReadPBDirectory';
Function _ReadPBEntry(Var pbe:TPBEntry; Var pbr):Integer; stdcall; external DLLNAME name 'ReadPBEntry';
Function _WritePBEntry(Var pbe:TPBEntry; Var pbr):Integer; stdcall; external DLLNAME name 'WritePBEntry';
Function _CreatePBEntry(Var pbe:TPBEntry; Var pbr):Integer;stdcall; external DLLNAME name 'CreatePBEntry';
Function _ErasePBEntry(Var pbe:TPBEntry):Integer; stdcall; external DLLNAME name 'ErasePBEntry';
Function _ReadCalDirectory(Var ce; MaxEntries:DWord):Integer; stdcall; external DLLNAME name 'ReadCalDirectory';
Function _ReadCalEntry(Var ce:TCalEntry; Var cr):Integer; stdcall; external DLLNAME name 'ReadCalEntry';
Function _WriteCalEntry(Var ce:TCalEntry; Var cr):Integer; stdcall; external DLLNAME name 'WriteCalEntry';
Function _CreateCalEntry(Var ce:TCalEntry; Var cr):Integer;stdcall; external DLLNAME name 'CreateCalEntry';
Function _EraseCalEntry(Var ce:TCalEntry):Integer; stdcall; external DLLNAME name 'EraseCalEntry';

Type PWord = ^Word;
     PDWord = ^DWord;

{***** TBPRecord ************************************************************}

Function TPBRecord.GetOnSIM:Boolean;
Begin
  Result:=(_Data[0] = 1);
end;

Procedure TPBRecord.SetOnSIM(Const PlaceOnSIM:Boolean);
Begin
  If PlaceOnSIM then
    _Data[0]:=1
  else
    _Data[0]:=0;
end;

Function TPBRecord.GetName:String;
Begin
  If PWord(@_Data[2])^ = 0 then
    Result:=''
  else
    WideCharLenToStrVar(PWideChar(@_Data[16]),20,Result);
end;

Procedure TPBRecord.SetName(Const NewName:String);
Begin
  FillChar(_Data[16],40,0);
  If NewName = '' then begin
    PWord(@_Data[2])^:=0; Exit;
  end;
  PWord(@_Data[2])^:=1;
  MultiByteToWideChar(0,0,PChar(NewName),Length(NewName),PWideChar(@_Data[16]),20);
end;

Function TPBRecord.GetNumberIcon(I:Byte):Integer;
Begin
  If (I>2) or (PWord(@_Data[4 + I*2])^ = 0) then begin
    Result:=-1; Exit;
  end;
  Result:=_Data[56 + I*42];
end;

Procedure TPBRecord.SetNumberIcon(I:Byte; NewIcon:Integer);
Begin
  If I>2 then Exit;
  If (NewIcon < 0) then begin
    PWord(@_Data[4 + I*2])^:=0; Exit;
  end;
  If PWord(@_Data[4 + I*2])^ = 0 then begin
    PWord(@_Data[4 + I*2])^:=1;
    FillChar(_Data[56 + I*42 + 1],41,0);
  end;
  _Data[56 + I*42]:=NewIcon;
end;

Function TPBRecord.GetNumber(I:Byte):String;
Begin
  If (I>2) or (PWord(@_Data[4 + I*2])^ = 0) then
    Result:=''
  else
    Result:=String(PChar(@_Data[56 + I*42 + 1]));
end;

Procedure TPBRecord.SetNumber(I:Byte; Const NewNumber:String);
Var Len:Integer;
Begin
  If I>2 then Exit;
  If NewNumber = '' then begin
    PWord(@_Data[4 + I*2])^:=0; Exit;
  end;
  FillChar(_Data[56 + I*42 + 1],41,0);
  If PWord(@_Data[4 + I*2])^ = 0 then begin
    PWord(@_Data[4 + I*2])^:=1;
    _Data[56 + I*42]:=0;
  end;
  Len:=Length(NewNumber);
  If Len>40 then Len:=40;
  If Len>0 then Move(PChar(NewNumber)^,_Data[56 + I*42 + 1],Len);
  _Data[56 + I*42 + 1 + Len]:=0;
end;

Function TPBRecord.GetNoteIcon(I:Byte):Integer;
Begin
  If (I>1) or (PWord(@_Data[10 + I*2])^ = 0) then begin
    Result:=-1; Exit;
  end;
  Result:=PWord(@_Data[182 + I*84])^;
end;

Procedure TPBRecord.SetNoteIcon(I:Byte; NewIcon:Integer);
Begin
  If I>1 then Exit;
  If NewIcon < 0 then begin
    PWord(@_Data[10 + I*2])^:=0; Exit;
  end;
  If PWord(@_Data[10 + I*2])^ = 0 then begin
    PWord(@_Data[10 + I*2])^:=1;
    FillChar(_Data[182 + I*84 + 2],42,0);
  end;
  PWord(@_Data[182 + I*84])^:=NewIcon;
end;

Function TPBRecord.GetNote(I:Byte):String;
Begin
  If (I>1) or (PWord(@_Data[10 + I*2])^ = 0) then
    Result:=''
  else
    WideCharLenToStrVar(PWideChar(@_Data[182 + I*84 + 4]),PWord(@_Data[182 + I*84 + 2])^,Result);
end;

Procedure TPBRecord.SetNote(I:Byte; Const NewNote:String);
Var Len:Integer;
Begin
  If I>1 then Exit;
  If NewNote = '' then begin
    PWord(@_Data[10 + I*2])^:=0; Exit;
  end;
  FillChar(_Data[182 + I*84 + 2],42,0);
  If PWord(@_Data[10 + I*2])^ = 0 then begin
    PWord(@_Data[10 + I*2])^:=1;
    PWord(@_Data[182 + I*84])^:=0;
  end;
  Len:=Length(NewNote);
  If Len>40 then Len:=40;
  If Len>0 then MultiByteToWideChar(0,0,PChar(NewNote),Length(NewNote),PWideChar(@_Data[182 + I*84 + 4]),Len);
  PWord(@_Data[182 + I*84 + 2])^:=Len;
end;

Procedure TPBRecord.Clear;
Begin
  FillChar(_Data,350,0);
end;

{***** TCalRecord ***********************************************************}

Function TCalRecord.GetIsToDo:Boolean;
Begin
  Result:=Boolean(PDWord(@_Data[0])^);
end;

Procedure TCalRecord.SetIsToDo(ToDo:Boolean);
Begin
  PDWord(@_Data[0])^:=DWord(ToDo);
end;

Function TCalRecord.GetDay:Byte;
Begin
  Result:=PDWord(@_Data[4])^ shr 11 and 31;
end;

Procedure TCalRecord.SetDay(A:Byte);
Begin
  If (A<1) then A:=1 else If (A>31) then A:=31;
  PDWord(@_Data[4])^:=PDWord(@_Data[4])^ and $FFFF07FF or (A shl 11);
end;

Function TCalRecord.GetMonth:Byte;
Begin
  Result:=PDWord(@_Data[4])^ shr 7 and 15;
end;

Procedure TCalRecord.SetMonth(A:Byte);
Begin
  If (A<1) then A:=1 else If (A>12) then A:=12;
  PDWord(@_Data[4])^:=PDWord(@_Data[4])^ and $FFFFF87F or (A shl 7);
end;

Function TCalRecord.GetYear:Byte;
Begin
  Result:=PDWord(@_Data[4])^ and 127;
end;

Procedure TCalRecord.SetYear(A:Byte);
Begin
  If (A>99) then A:=99;
  PDWord(@_Data[4])^:=PDWord(@_Data[4])^ and $FFFFFF80 or A;
end;

Function TCalRecord.GetHour:Byte;
Begin
  Result:=PDWord(@_Data[4])^ shr 16 and 31;
end;

Procedure TCalRecord.SetHour(A:Byte);
Begin
  If (A>23) then A:=23;
  PDWord(@_Data[4])^:=PDWord(@_Data[4])^ and $FFE0FFFF or (A shl 16);
end;

Function TCalRecord.GetMinute:Byte;
Begin
  Result:=PDWord(@_Data[4])^ shr 21 and 63;
end;

Procedure TCalRecord.SetMinute(A:Byte);
Begin
  If (A>59) then A:=59;
  PDWord(@_Data[4])^:=PDWord(@_Data[4])^ and $F81FFFFF or (A shl 21);
end;

Function TCalRecord.GetAlarm:Byte;
Begin
  Result:=PDWord(@_Data[4])^ shr 27 and 3;
end;

Procedure TCalRecord.SetAlarm(A:Byte);
Begin
  If (A>3) then A:=3;
  PDWord(@_Data[4])^:=PDWord(@_Data[4])^ and $E7FFFFFF or (A shl 27);
end;

Function TCalRecord.GetIcon:Word;
Begin
  Result:=PWord(@_Data[8])^;
end;

Procedure TCalRecord.SetIcon(A:Word);
Begin
  PWord(@_Data[8])^:=A;
end;

Function TCalRecord.GetText:String;
Begin
  WideCharLenToStrVar(PWideChar(@_Data[10]),20,Result);
end;

Procedure TCalRecord.SetText(Const A:String);
Begin
  FillChar(_Data[10],42,0);
  If (A = '') then Exit;
  MultiByteToWideChar(0,0,PChar(A),Length(A),PWideChar(@_Data[10]),20);
end;

Function TCalRecord.GetCompleted:Boolean;
Begin
  Result:=PDWord(@_Data[4])^ and $40000000 <> 0;
end;

Procedure TCalRecord.SetCompleted(A:Boolean);
Begin
  PDWord(@_Data[4])^:=PDWord(@_Data[4])^ and $BFFFFFFF or (DWord(A) shl 30);
end;

Procedure TCalRecord.Clear;
Begin
  FillChar(_Data,52,0);
end;

{***** TGBPControl **********************************************************}

Function TGBPControl.Init(PortNum:Byte):Integer;
Begin
  Result:=_InitGBPMode(PortNum);
end;

Function TGBPControl.Close:Integer;
Begin
  Result:=_EndGBPMode;
end;

Function TGBPControl.GetNVMSize(Section,Subsection:Byte):Integer;
Begin
  Result:=_GetNVMFileSize(Section,Subsection);
end;

Function TGBPControl.ClearNVMFile(Section,Subsection:Byte):Integer;
Begin
  Result:=_ClearNVMFile(Section,Subsection);
end;

Function TGBPControl.ReadNVMFile(Section,Subsection:Byte; Var SrcBuffer; MaxSize:DWord):Integer;
Begin
  Result:=_ReadNVMFile(Section,Subsection,SrcBuffer,MaxSize);
end;

Function TGBPControl.WriteNVMFile(Section,Subsection:Byte; Var DestBuffer; Size:DWord):Integer;
Begin
  Result:=_WriteNVMFile(Section,Subsection,DestBuffer,Size);
end;

Function TGBPControl.ClearLock:Integer;
Begin
  Result:=_ClearLock;
end;

Function TGBPControl.ReadPBDirectory(Var pbe:Array Of TPBEntry; MaxEntries:DWord):Integer;
Begin
  Result:=_ReadPBDirectory(pbe,MaxEntries);
end;

Function TGBPControl.ReadPBEntry(Var pbe:TPBEntry; Var pbr:TPBRecord):Integer;
Begin
  Result:=_ReadPBEntry(pbe,pbr._Data);
end;

Function TGBPControl.WritePBEntry(Var pbe:TPBEntry; Var pbr:TPBRecord):Integer;
Begin
  Result:=_WritePBEntry(pbe,pbr._Data);
end;

Function TGBPControl.CreatePBEntry(Var pbe:TPBEntry; Var pbr:TPBRecord):Integer;
Begin
  Result:=_CreatePBEntry(pbe,pbr._Data);
end;

Function TGBPControl.ErasePBEntry(Var pbe:TPBEntry):Integer;
Begin
  Result:=_ErasePBEntry(pbe);
end;

Function TGBPControl.ReadCalDirectory(Var ce:Array Of TCalEntry; MaxEntries:DWord):Integer;
Begin
  Result:=_ReadCalDirectory(ce,MaxEntries);
end;

Function TGBPControl.ReadCalEntry(Var ce:TCalEntry; Var cr:TCalRecord):Integer;
Begin
  Result:=_ReadCalEntry(ce,cr._Data);
end;

Function TGBPControl.WriteCalEntry(Var ce:TCalEntry; Var cr:TCalRecord):Integer;
Begin
  Result:=_WriteCalEntry(ce,cr._Data);
end;

Function TGBPControl.CreateCalEntry(Var ce:TCalEntry; Var cr:TCalRecord):Integer;
Begin
  Result:=_CreateCalEntry(ce,cr._Data);
end;

Function TGBPControl.EraseCalEntry(Var ce:TCalEntry):Integer;
Begin
  Result:=_EraseCalEntry(ce);
end;

end.
